<!DOCTYPE html><html lang="zh-CN" data-theme="light"><head><meta charset="UTF-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1"><title>Dokcer+Prometheus+Grafana监控 | SeMaik</title><meta name="author" content="ZuSir"><meta name="copyright" content="ZuSir"><meta name="format-detection" content="telephone=no"><meta name="theme-color" content="#ffffff"><meta name="description" content="介绍Prometheus需要多种第三方工具来收集数据，如接下来要使用的cAdvisor和node-exporter，最终Prometheus使用Grafana进行监控数据的展示Prometheus是一套开源的监控&amp;报警&amp;时间序列数据库的组合，起始是由SoundCloud公司开发的。随着发展，越来越多公司和组织接受采用Prometheus，社区也十分活跃，他们便将它独立成开源项目，">
<meta property="og:type" content="article">
<meta property="og:title" content="Dokcer+Prometheus+Grafana监控">
<meta property="og:url" content="http://example.com/2021/04/21/Dokcer-Prometheus-Grafana%E7%9B%91%E6%8E%A7/index.html">
<meta property="og:site_name" content="SeMaik">
<meta property="og:description" content="介绍Prometheus需要多种第三方工具来收集数据，如接下来要使用的cAdvisor和node-exporter，最终Prometheus使用Grafana进行监控数据的展示Prometheus是一套开源的监控&amp;报警&amp;时间序列数据库的组合，起始是由SoundCloud公司开发的。随着发展，越来越多公司和组织接受采用Prometheus，社区也十分活跃，他们便将它独立成开源项目，">
<meta property="og:locale" content="zh_CN">
<meta property="og:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg">
<meta property="article:published_time" content="2021-04-21T02:01:00.000Z">
<meta property="article:modified_time" content="2021-04-21T03:04:48.000Z">
<meta property="article:author" content="ZuSir">
<meta name="twitter:card" content="summary">
<meta name="twitter:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg"><link rel="shortcut icon" href="https://myit.icu/favicon.ico"><link rel="canonical" href="http://example.com/2021/04/21/Dokcer-Prometheus-Grafana%E7%9B%91%E6%8E%A7/"><link rel="preconnect" href="//cdn.jsdelivr.net"/><link rel="preconnect" href="//busuanzi.ibruce.info"/><link rel="stylesheet" href="/css/index.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free/css/all.min.css" media="print" onload="this.media='all'"><script>const GLOBAL_CONFIG = { 
  root: '/',
  algolia: undefined,
  localSearch: undefined,
  translate: undefined,
  noticeOutdate: undefined,
  highlight: {"plugin":"highlighjs","highlightCopy":true,"highlightLang":true},
  copy: {
    success: '复制成功',
    error: '复制错误',
    noSupport: '浏览器不支持'
  },
  relativeDate: {
    homepage: true,
    post: false
  },
  runtime: '',
  date_suffix: {
    just: '刚刚',
    min: '分钟前',
    hour: '小时前',
    day: '天前',
    month: '个月前'
  },
  copyright: undefined,
  lightbox: 'fancybox',
  Snackbar: undefined,
  source: {
    jQuery: 'https://cdn.jsdelivr.net/npm/jquery@latest/dist/jquery.min.js',
    justifiedGallery: {
      js: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/js/jquery.justifiedGallery.min.js',
      css: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/css/justifiedGallery.min.css'
    },
    fancybox: {
      js: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.js',
      css: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.css'
    }
  },
  isPhotoFigcaption: false,
  islazyload: false,
  isanchor: false
}</script><script id="config-diff">var GLOBAL_CONFIG_SITE = { 
  isPost: true,
  isHome: false,
  isHighlightShrink: undefined,
  isToc: true,
  postUpdate: '2021-04-21 11:04:48'
}</script><noscript><style type="text/css">
  #nav {
    opacity: 1
  }
  .justified-gallery img {
    opacity: 1
  }

  #recent-posts time,
  #post-meta time {
    display: inline !important
  }
</style></noscript><script>(win=>{
    win.saveToLocal = {
      set: function setWithExpiry(key, value, ttl) {
        if (ttl === 0) return
        const now = new Date()
        const expiryDay = ttl * 86400000
        const item = {
          value: value,
          expiry: now.getTime() + expiryDay,
        }
        localStorage.setItem(key, JSON.stringify(item))
      },

      get: function getWithExpiry(key) {
        const itemStr = localStorage.getItem(key)

        if (!itemStr) {
          return undefined
        }
        const item = JSON.parse(itemStr)
        const now = new Date()

        if (now.getTime() > item.expiry) {
          localStorage.removeItem(key)
          return undefined
        }
        return item.value
      }
    }
  
    win.getScript = url => new Promise((resolve, reject) => {
      const script = document.createElement('script')
      script.src = url
      script.async = true
      script.onerror = reject
      script.onload = script.onreadystatechange = function() {
        const loadState = this.readyState
        if (loadState && loadState !== 'loaded' && loadState !== 'complete') return
        script.onload = script.onreadystatechange = null
        resolve()
      }
      document.head.appendChild(script)
    })
  
      const asideStatus = saveToLocal.get('aside-status')
      if (asideStatus !== undefined) {
        if (asideStatus === 'hide') {
          document.documentElement.classList.add('hide-aside')
        } else {
          document.documentElement.classList.remove('hide-aside')
        }
      }
    })(window)</script><link href="/css/style.css"><meta name="generator" content="Hexo 5.3.0"><link rel="alternate" href="/atom.xml" title="SeMaik" type="application/atom+xml">
</head><body><div id="web_bg"></div><div id="sidebar"><div id="menu-mask"></div><div id="sidebar-menus"><div class="author-avatar"><img class="avatar-img" src="/img/123.jpeg" onerror="onerror=null;src='/img/123.jpeg'" alt="avatar"/></div><div class="site-data"><div class="data-item is-center"><div class="data-item-link"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div></div><div class="data-item is-center"><div class="data-item-link"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><hr/><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div></div></div><div class="post" id="body-wrap"><header class="post-bg" id="page-header" style="background-image: url('https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg')"><nav id="nav"><span id="blog_name"><a id="site-name" href="/">SeMaik</a></span><div id="menus"><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div><div id="toggle-menu"><a class="site-page"><i class="fas fa-bars fa-fw"></i></a></div></div></nav><div id="post-info"><h1 class="post-title">Dokcer+Prometheus+Grafana监控</h1><div id="post-meta"><div class="meta-firstline"><span class="post-meta-date"><i class="far fa-calendar-alt fa-fw post-meta-icon"></i><span class="post-meta-label">发表于</span><time class="post-meta-date-created" datetime="2021-04-21T02:01:00.000Z" title="发表于 2021-04-21 10:01:00">2021-04-21</time><span class="post-meta-separator">|</span><i class="fas fa-history fa-fw post-meta-icon"></i><span class="post-meta-label">更新于</span><time class="post-meta-date-updated" datetime="2021-04-21T03:04:48.000Z" title="更新于 2021-04-21 11:04:48">2021-04-21</time></span><span class="post-meta-categories"><span class="post-meta-separator">|</span><i class="fas fa-inbox fa-fw post-meta-icon"></i><a class="post-meta-categories" href="/categories/Docker/">Docker</a></span></div><div class="meta-secondline"><span class="post-meta-separator">|</span><span class="post-meta-pv-cv"><i class="far fa-eye fa-fw post-meta-icon"></i><span class="post-meta-label">阅读量:</span><span id="busuanzi_value_page_pv"></span></span></div></div></div></header><main class="layout" id="content-inner"><div id="post"><article class="post-content" id="article-container"><p><img src="/images/pasted-239.png" alt="upload successful"></p>
<h2 id="介绍"><a href="#介绍" class="headerlink" title="介绍"></a>介绍</h2><p>Prometheus需要多种第三方工具来收集数据，如接下来要使用的cAdvisor和node-exporter，最终Prometheus使用Grafana进行监控数据的展示<br>Prometheus是一套开源的监控&amp;报警&amp;时间序列数据库的组合，起始是由SoundCloud公司开发的。随着发展，越来越多公司和组织接受采用Prometheus，社区也十分活跃，他们便将它独立成开源项目，并且有公司来运作。google SRE的书内也曾提到跟他们BorgMon监控系统相似的实现是Prometheus。现在最常见的Kubernetes容器管理系统中，通常会搭配Prometheus进行监控。</p>
<h2 id="Prometheus-的优点"><a href="#Prometheus-的优点" class="headerlink" title="Prometheus 的优点"></a>Prometheus 的优点</h2><ul>
<li>非常少的外部依赖，安装使用超简单</li>
<li>已经有非常多的系统集成 例如：docker HAProxy Nginx JMX等等</li>
<li>服务自动化发现</li>
<li>直接集成到代码</li>
<li>设计思想是按照分布式、微服务架构来实现的</li>
</ul>
<h2 id="Prometheus-的特性"><a href="#Prometheus-的特性" class="headerlink" title="Prometheus 的特性"></a>Prometheus 的特性</h2><ul>
<li>自定义多维度的数据模型</li>
<li>非常高效的存储 平均一个采样数据占 ~3.5 bytes左右，320万的时间序列，每30秒采样，保持60天，消耗磁盘大概228G。</li>
<li>强大的查询语句</li>
<li>轻松实现数据可视化</li>
</ul>
<h2 id="Prometheus的牛逼之处"><a href="#Prometheus的牛逼之处" class="headerlink" title="Prometheus的牛逼之处"></a>Prometheus的牛逼之处</h2><p>Prometheus是一个非常优秀的监控工具。准确的说，应该是监控方案。Prometheus提供了监控数据搜集，存储，处理，可视化和告警一套完整的解决方案;<br>可以将它理解为图表显示器，或者资源整合器</p>
<p>下面是Prometheus的框架结构。如图。</p>
<p><img src="/images/pasted-241.png" alt="upload successful"></p>
<p>相关组件：</p>
<ul>
<li>Prometheus Server<br>Prometheus Server负责从运行了node-exporter拉取和存储监控数据，并提供一套灵活的查询语言（promQL）供用户使用</li>
<li>node-exporter<br>exporter负责收集目标对象（host，container。。。）的性能数据，并通过HTTP接口供prometheus server获取</li>
<li>WebUI/Grafana/API clients<br>是一系列的可视化组件<br>监控数据的可视化展示对于监控方案至关重要。之前prometheus自己开发了一套工具，不过后来废弃了，因为开源社区出现了更优秀的产品：Grafana。Grafana能够与Prometheus无缝集成，提供完美的数据展示功能。</li>
<li>Alertmanager<br>用户可以定义基于数据监控的告警规则，规则会触发告警，会通过预定义的方式发出告警通知。支持的方式包括Email，pagerduty，webhook等</li>
</ul>
<h2 id="Prometheus的亮点"><a href="#Prometheus的亮点" class="headerlink" title="Prometheus的亮点"></a>Prometheus的亮点</h2><p>prometheus最大的亮点和先进性是他的多维数据模型<br>多维可以理解为，可以从不同的角度去让用户获取到用户想要看到的监控数据，比如同样是监控内存的使用情况，可以监控容器、镜像、user等使用内存的情况。</p>
<h2 id="Prometheus的优势"><a href="#Prometheus的优势" class="headerlink" title="Prometheus的优势"></a>Prometheus的优势</h2><ul>
<li>通过维度对数据进行说明，附加更多的业务信息，进而满足不同业务的需求。同时维度是可以动态添加的，比如再给数据添加一个user维度，就可以按照用户来统计内存的使用量了。</li>
<li>prometheus丰富的查询语句能够灵活，充分挖掘数据的价值。比如对数据进行计算，这些只是查询语言中很小的一部分功能。Prometheus 对多维数据进行分片、聚合的强大能力。</li>
</ul>
<h2 id="主机信息"><a href="#主机信息" class="headerlink" title="主机信息"></a>主机信息</h2><table>
<thead>
<tr>
<th align="center">hostname</th>
<th align="center">IP</th>
<th align="center">服务</th>
</tr>
</thead>
<tbody><tr>
<td align="center">Server1</td>
<td align="center">172.16.1.16</td>
<td align="center">Docker</td>
</tr>
<tr>
<td align="center">Server2</td>
<td align="center">172.16.1.17</td>
<td align="center">Docker</td>
</tr>
</tbody></table>
<h2 id="部署监控"><a href="#部署监控" class="headerlink" title="部署监控"></a>部署监控</h2><p>node-exporter：负责采集主机的信息和操作系统的信息，以容器的方式运行在监控主机上<br>cAdvisor：负责采集容器的信息，以容器的方式运行在监控主机上，主要功能：展示主机和容器两个层次的监控数据、展示历史变化数据、在与Prometheus搭配使用时，可以将cAdvisor定位为一个监控数据收集器，收集和导出数据是它的强项，而非展示数据。</p>
<h2 id="下载镜像"><a href="#下载镜像" class="headerlink" title="下载镜像"></a>下载镜像</h2><p>只需要在一台中进行下载Prometheus的镜像即可，作为Prometheus服务器<br>node-exporter主要用来收集主机的硬件使用数据，这样就可以使用cAdvisor和node-exporter将容器与主机的数据都进行了收集</p>
<h3 id="Server1"><a href="#Server1" class="headerlink" title="Server1"></a>Server1</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">[root@Server1 ~]# docker pull prom&#x2F;prometheus</span><br><span class="line">[root@Server1 ~]# docker pull prom&#x2F;node-exporter</span><br><span class="line">[root@Server1 ~]# docker pull google&#x2F;cadvisor</span><br><span class="line">[root@Server1 ~]# docker pull grafana&#x2F;grafana</span><br></pre></td></tr></table></figure>
<h3 id="Server2"><a href="#Server2" class="headerlink" title="Server2"></a>Server2</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">[root@Server2 ~]# docker pull prom&#x2F;node-exporter</span><br></pre></td></tr></table></figure>
<h2 id="运行export容器"><a href="#运行export容器" class="headerlink" title="运行export容器"></a>运行export容器</h2><p>exporter端口为：9100<br>以下映射的目录大部分都在/var/lib/docker目录下</p>
<h3 id="Server1-1"><a href="#Server1-1" class="headerlink" title="Server1"></a>Server1</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br></pre></td><td class="code"><pre><span class="line">docker run -d -p 9100:9100 --volume &#x2F;proc&#x2F;:&#x2F;host&#x2F;proc \</span><br><span class="line">--volume &#x2F;sys&#x2F;:&#x2F;host&#x2F;sys --volume &#x2F;:&#x2F;rootfs --name exporter \</span><br><span class="line">prom&#x2F;node-exporter --path.procfs &#x2F;host&#x2F;proc --path.sysfs &#x2F;host&#x2F;sys \</span><br><span class="line">--collector.filesystem.ignored-mount-points \</span><br><span class="line">&quot;^(sys|proc|dev|host|etc|rootfs&#x2F;var&#x2F;lib&#x2F;docker&#x2F;containers\</span><br><span class="line">|rootfs&#x2F;var&#x2F;lib&#x2F;docker&#x2F;overlay2\</span><br><span class="line">|rootfs&#x2F;run&#x2F;docker&#x2F;netns|rootfs&#x2F;var&#x2F;lib&#x2F;docker&#x2F;devicemapper\</span><br><span class="line">|rootfs&#x2F;var&#x2F;lib&#x2F;docker&#x2F;aufs)($$|&#x2F;)&quot;</span><br></pre></td></tr></table></figure>
<h3 id="Server2-1"><a href="#Server2-1" class="headerlink" title="Server2"></a>Server2</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br></pre></td><td class="code"><pre><span class="line">docker run -d -p 9100:9100 --volume &#x2F;proc&#x2F;:&#x2F;host&#x2F;proc \</span><br><span class="line">--volume &#x2F;sys&#x2F;:&#x2F;host&#x2F;sys --volume &#x2F;:&#x2F;rootfs --name exporter \</span><br><span class="line">prom&#x2F;node-exporter --path.procfs &#x2F;host&#x2F;proc --path.sysfs &#x2F;host&#x2F;sys \</span><br><span class="line">--collector.filesystem.ignored-mount-points \</span><br><span class="line">&quot;^(sys|proc|dev|host|etc|rootfs&#x2F;var&#x2F;lib&#x2F;docker&#x2F;containers\</span><br><span class="line">|rootfs&#x2F;var&#x2F;lib&#x2F;docker&#x2F;overlay2\</span><br><span class="line">|rootfs&#x2F;run&#x2F;docker&#x2F;netns|rootfs&#x2F;var&#x2F;lib&#x2F;docker&#x2F;devicemapper\</span><br><span class="line">|rootfs&#x2F;var&#x2F;lib&#x2F;docker&#x2F;aufs)($$|&#x2F;)&quot;</span><br></pre></td></tr></table></figure>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">[root@Server1 ~]# systemctl stop firewalld</span><br></pre></td></tr></table></figure>
<p>访问: <code>http://172.16.1.16:9100/metrics</code></p>
<p><img src="/images/pasted-242.png" alt="upload successful"></p>
<h2 id="运行cadvisor容器"><a href="#运行cadvisor容器" class="headerlink" title="运行cadvisor容器"></a>运行cadvisor容器</h2><p>cAdvisor的端口号是8080</p>
<h3 id="Server1-2"><a href="#Server1-2" class="headerlink" title="Server1"></a>Server1</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">docker run --volume &#x2F;:&#x2F;rootfs:ro --volume &#x2F;var&#x2F;run:&#x2F;var&#x2F;run:rw \</span><br><span class="line">--volume &#x2F;sys:&#x2F;sys:ro --volume &#x2F;var&#x2F;lib&#x2F;docker:&#x2F;var&#x2F;lib&#x2F;docker:ro \</span><br><span class="line">-d -p 8080:8080 --name cadvisor google&#x2F;cadvisor </span><br></pre></td></tr></table></figure>
<h3 id="Server2-2"><a href="#Server2-2" class="headerlink" title="Server2"></a>Server2</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">docker run --volume &#x2F;:&#x2F;rootfs:ro --volume &#x2F;var&#x2F;run:&#x2F;var&#x2F;run:rw \</span><br><span class="line">--volume &#x2F;sys:&#x2F;sys:ro --volume &#x2F;var&#x2F;lib&#x2F;docker:&#x2F;var&#x2F;lib&#x2F;docker:ro \</span><br><span class="line">-d -p 8080:8080 --name cadvisor google&#x2F;cadvisor </span><br></pre></td></tr></table></figure>
<p>访问：<code>http://172.16.1.16:8080/metrics</code></p>
<p><img src="/images/pasted-243.png" alt="upload successful"></p>
<h2 id="运行Prometheus"><a href="#运行Prometheus" class="headerlink" title="运行Prometheus"></a>运行Prometheus</h2><p>需要使用一个yml文件来指定需要监控的内容，将两台主机的cAdvisor与exporter监控到的数据拉取到Prometheus Server中<br>将这个配置文件映射到Prometheus Server的容器中<br>去官网找示例文件，修改为如下，我这里是使用的官网的最下面的那个示例，截止到startic_configs：<br>修改内容：rule_files注释掉，添加static_configs:下面的内容，用来指定exporter抓取的数据</p>
<h3 id="Server1-3"><a href="#Server1-3" class="headerlink" title="Server1"></a>Server1</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br></pre></td><td class="code"><pre><span class="line">[root@Server1 ~]# vim prometheus.yml</span><br><span class="line">global:</span><br><span class="line">  scrape_interval:     15s # By default, scrape targets every 15 seconds.</span><br><span class="line">  evaluation_interval: 15s # Evaluate rules every 15 seconds.</span><br><span class="line"> </span><br><span class="line">  # Attach these labels to any time series or alerts when communicating with</span><br><span class="line">  # external systems (federation, remote storage, Alertmanager).</span><br><span class="line">  external_labels:</span><br><span class="line">    monitor: &#39;codelab-monitor&#39;</span><br><span class="line"> </span><br><span class="line">rule_files:</span><br><span class="line">  # - &#39;prometheus.rules.yml&#39;</span><br><span class="line"> </span><br><span class="line">scrape_configs:</span><br><span class="line">  - job_name: &#39;prometheus&#39;</span><br><span class="line"> </span><br><span class="line">    # Override the global default and scrape targets from this job every 5 seconds.</span><br><span class="line">    #     scrape_interval: 5s</span><br><span class="line">     </span><br><span class="line">    static_configs:</span><br><span class="line">      - targets: [&#39;172.16.1.16:9090&#39;,&#39;172.16.1.16:8080&#39;,&#39;172.16.1.16:9100&#39;,&#39;172.16.1.17:8080&#39;,&#39;172.16.1.17:9100&#39;]</span><br></pre></td></tr></table></figure>
<p>在以上文件中，将两台主机的5个ip:port都添加即可，<code>9090为Prometheus Server</code>的端口</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">docker run -d --volume &#x2F;root&#x2F;prometheus.yml:&#x2F;etc&#x2F;prometheus&#x2F;prometheus.yml --name prometheus -p 9090:9090 prom&#x2F;prometheus</span><br></pre></td></tr></table></figure>
<p>访问<code>172.16.1.16:9090</code><br><img src="/images/pasted-244.png" alt="upload successful"></p>
<h2 id="运行Grafana"><a href="#运行Grafana" class="headerlink" title="运行Grafana"></a>运行Grafana</h2><p>使用grafana可以显示更加绚丽的图形化界面<br><code>grafana的端口号是3000</code></p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">[root@Server1 ~]# docker run -d -i --name grafana \</span><br><span class="line">-e &quot;GF_SERVER_ROOT_URL&#x3D;http:&#x2F;&#x2F;grafana.server.name&quot; \</span><br><span class="line">-e &quot;GF_SECURITY_ADMIN_PASSWORD&#x3D;secret&quot; -p 3000:3000 grafana&#x2F;grafana</span><br></pre></td></tr></table></figure>
<p>访问<code>http://172.16.1.16:3000</code><br>默认用户名：<code>admin</code> 密码：<code>secret</code></p>
<p><img src="/images/pasted-245.png" alt="upload successful"></p>
<p>连接Prometheus</p>
<p><img src="/images/pasted-246.png" alt="upload successful"></p>
<p><img src="/images/pasted-247.png" alt="upload successful"></p>
<p><img src="/images/pasted-248.png" alt="upload successful"><br>点击下方<code>Save &amp; Test</code> 保存<br>添加监控面板</p>
<p><img src="/images/pasted-249.png" alt="upload successful"><br>这里需要导入json文件，在grafana官网即可下载；<br><code>https://grafana.com/grafana/dashboards?dataSource=prometheus&amp;search=Docker</code></p>
<p><img src="/images/pasted-250.png" alt="upload successful"></p>
<p><img src="/images/pasted-251.png" alt="upload successful"><br>导入之后点击<code>Import</code>即可！</p>
<p>由于之前下载了中文版面板，我这里就直接用中文版了，看起来还不错！</p>
<p><img src="/images/pasted-252.png" alt="upload successful"></p>
<h2 id="例：新添加监控主机"><a href="#例：新添加监控主机" class="headerlink" title="例：新添加监控主机"></a>例：新添加监控主机</h2><p>如果后期需要新加监控主机，需要在prometheus.yml文件中末尾targets中添加新主机的IP+8080/9100端口，重启cadivsor和Prometheus容器即可！<br>新加主机：<code>172.16.1.18</code></p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">[root@Server1 ~]# vi prometheus.yml</span><br><span class="line">- targets: [&#39;172.16.1.16:9090&#39;,&#39;172.16.1.16:8080&#39;,&#39;172.16.1.16:9100&#39;,&#39;172.16.1.17:8080&#39;,&#39;172.1172.16.1.18:8080&#39;,&#39;172.16.1.18:9100&#39;]</span><br><span class="line"></span><br><span class="line">[root@Server1 ~]# docker restart cadvisor</span><br><span class="line">[root@Server1 ~]# docker restart prometheus</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-253.png" alt="upload successful"></p>
</article><div class="post-copyright"><div class="post-copyright__author"><span class="post-copyright-meta">文章作者: </span><span class="post-copyright-info"><a href="mailto:undefined">ZuSir</a></span></div><div class="post-copyright__type"><span class="post-copyright-meta">文章链接: </span><span class="post-copyright-info"><a href="http://example.com/2021/04/21/Dokcer-Prometheus-Grafana%E7%9B%91%E6%8E%A7/">http://example.com/2021/04/21/Dokcer-Prometheus-Grafana%E7%9B%91%E6%8E%A7/</a></span></div><div class="post-copyright__notice"><span class="post-copyright-meta">版权声明: </span><span class="post-copyright-info">本博客所有文章除特别声明外，均采用 <a href="https://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC BY-NC-SA 4.0</a> 许可协议。转载请注明来自 <a href="http://example.com" target="_blank">SeMaik</a>！</span></div></div><div class="tag_share"><div class="post-meta__tag-list"></div><div class="post_share"><div class="social-share" data-image="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" data-sites="facebook,twitter,wechat,weibo,qq"></div><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/social-share.js/dist/css/share.min.css" media="print" onload="this.media='all'"><script src="https://cdn.jsdelivr.net/npm/social-share.js/dist/js/social-share.min.js" defer></script></div></div><nav class="pagination-post" id="pagination"><div class="prev-post pull-left"><a href="/2021/05/12/k8s%E9%83%A8%E7%BD%B2nginx-php/"><img class="prev-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of previous post"><div class="pagination-info"><div class="label">上一篇</div><div class="prev_info">Kubernetes部署nginx+php</div></div></a></div><div class="next-post pull-right"><a href="/2021/04/20/Docker-Scope%E5%AE%B9%E5%99%A8%E7%9B%91%E6%8E%A7/"><img class="next-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of next post"><div class="pagination-info"><div class="label">下一篇</div><div class="next_info">Docker-Scope容器监控</div></div></a></div></nav></div><div class="aside-content" id="aside-content"><div class="card-widget card-info"><div class="card-info-avatar is-center"><img class="avatar-img" src="/img/123.jpeg" onerror="this.onerror=null;this.src='/img/123.jpeg'" alt="avatar"/><div class="author-info__name">ZuSir</div><div class="author-info__description">一个收藏回忆与分享技术的地方!</div></div><div class="card-info-data"><div class="card-info-data-item is-center"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div><div class="card-info-data-item is-center"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><div class="card-widget card-announcement"><div class="item-headline"><i class="fas fa-bullhorn card-announcement-animation"></i><span>公告</span></div><div class="announcement_content">This is my Blog! <img src="https://ss0.bdstatic.com/70cFuHSh_Q1YnxGkpoWK1HF6hhy/it/u=3894415926,2787041726&fm=26&gp=0.jpg"></div></div><div class="sticky_layout"><div class="card-widget" id="card-toc"><div class="item-headline"><i class="fas fa-stream"></i><span>目录</span></div><div class="toc-content"><ol class="toc"><li class="toc-item toc-level-2"><a class="toc-link" href="#%E4%BB%8B%E7%BB%8D"><span class="toc-number">1.</span> <span class="toc-text">介绍</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#Prometheus-%E7%9A%84%E4%BC%98%E7%82%B9"><span class="toc-number">2.</span> <span class="toc-text">Prometheus 的优点</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#Prometheus-%E7%9A%84%E7%89%B9%E6%80%A7"><span class="toc-number">3.</span> <span class="toc-text">Prometheus 的特性</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#Prometheus%E7%9A%84%E7%89%9B%E9%80%BC%E4%B9%8B%E5%A4%84"><span class="toc-number">4.</span> <span class="toc-text">Prometheus的牛逼之处</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#Prometheus%E7%9A%84%E4%BA%AE%E7%82%B9"><span class="toc-number">5.</span> <span class="toc-text">Prometheus的亮点</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#Prometheus%E7%9A%84%E4%BC%98%E5%8A%BF"><span class="toc-number">6.</span> <span class="toc-text">Prometheus的优势</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E4%B8%BB%E6%9C%BA%E4%BF%A1%E6%81%AF"><span class="toc-number">7.</span> <span class="toc-text">主机信息</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2%E7%9B%91%E6%8E%A7"><span class="toc-number">8.</span> <span class="toc-text">部署监控</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E4%B8%8B%E8%BD%BD%E9%95%9C%E5%83%8F"><span class="toc-number">9.</span> <span class="toc-text">下载镜像</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#Server1"><span class="toc-number">9.1.</span> <span class="toc-text">Server1</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#Server2"><span class="toc-number">9.2.</span> <span class="toc-text">Server2</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E8%BF%90%E8%A1%8Cexport%E5%AE%B9%E5%99%A8"><span class="toc-number">10.</span> <span class="toc-text">运行export容器</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#Server1-1"><span class="toc-number">10.1.</span> <span class="toc-text">Server1</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#Server2-1"><span class="toc-number">10.2.</span> <span class="toc-text">Server2</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E8%BF%90%E8%A1%8Ccadvisor%E5%AE%B9%E5%99%A8"><span class="toc-number">11.</span> <span class="toc-text">运行cadvisor容器</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#Server1-2"><span class="toc-number">11.1.</span> <span class="toc-text">Server1</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#Server2-2"><span class="toc-number">11.2.</span> <span class="toc-text">Server2</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E8%BF%90%E8%A1%8CPrometheus"><span class="toc-number">12.</span> <span class="toc-text">运行Prometheus</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#Server1-3"><span class="toc-number">12.1.</span> <span class="toc-text">Server1</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E8%BF%90%E8%A1%8CGrafana"><span class="toc-number">13.</span> <span class="toc-text">运行Grafana</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E4%BE%8B%EF%BC%9A%E6%96%B0%E6%B7%BB%E5%8A%A0%E7%9B%91%E6%8E%A7%E4%B8%BB%E6%9C%BA"><span class="toc-number">14.</span> <span class="toc-text">例：新添加监控主机</span></a></li></ol></div></div><div class="card-widget card-recent-post"><div class="item-headline"><i class="fas fa-history"></i><span>最新文章</span></div><div class="aside-list"><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Zabbix-Server5-0/" title="Shell程序——部署Zabbix-ServerV5.0">Shell程序——部署Zabbix-ServerV5.0</a><time datetime="2022-02-17T03:32:00.000Z" title="发表于 2022-02-17 11:32:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Harbor/" title="Shell程序——部署Harbor">Shell程序——部署Harbor</a><time datetime="2022-02-17T03:31:00.000Z" title="发表于 2022-02-17 11:31:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94Mysql%E5%A4%87%E4%BB%BD/" title="Shell程序——Mysql备份">Shell程序——Mysql备份</a><time datetime="2022-02-17T03:30:00.000Z" title="发表于 2022-02-17 11:30:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E6%89%B9%E9%87%8F%E4%BF%9D%E5%AD%98Docker-image/" title="Shell程序——批量保存Docker_image">Shell程序——批量保存Docker_image</a><time datetime="2022-02-17T03:29:00.000Z" title="发表于 2022-02-17 11:29:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E5%85%A8%E6%AE%B5IP%E6%89%AB%E6%8F%8F/" title="Shell程序——全段IP扫描">Shell程序——全段IP扫描</a><time datetime="2022-02-17T03:28:00.000Z" title="发表于 2022-02-17 11:28:00">2022-02-17</time></div></div></div></div></div></div></main><footer id="footer"><div id="footer-wrap"><div class="copyright">&copy;2020 - 2022 By ZuSir</div><div class="framework-info"><span>框架 </span><a target="_blank" rel="noopener" href="https://hexo.io">Hexo</a><span class="footer-separator">|</span><span>主题 </span><a target="_blank" rel="noopener" href="https://github.com/jerryc127/hexo-theme-butterfly">Butterfly</a></div></div></footer></div><div id="rightside"><div id="rightside-config-hide"><button id="readmode" type="button" title="阅读模式"><i class="fas fa-book-open"></i></button><button id="hide-aside-btn" type="button" title="单栏和双栏切换"><i class="fas fa-arrows-alt-h"></i></button></div><div id="rightside-config-show"><button id="rightside_config" type="button" title="设置"><i class="fas fa-cog fa-spin"></i></button><button class="close" id="mobile-toc-button" type="button" title="目录"><i class="fas fa-list-ul"></i></button><button id="go-up" type="button" title="回到顶部"><i class="fas fa-arrow-up"></i></button></div></div><div><script src="/js/utils.js"></script><script src="/js/main.js"></script><div class="js-pjax"></div><script defer="defer" id="fluttering_ribbon" mobile="true" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/dist/canvas-fluttering-ribbon.min.js"></script><script async data-pjax src="//busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script></div></body></html>